import { ProjectDeleteEffect } from './ngrx/project/project.effects.delete';
import { ProjectUpdateEffect } from './ngrx/project/project.effects.update';
import { ProjectGetEffects } from './ngrx/project/project.effects.get';
import { ProjectCreateEffects } from './ngrx/project/project.effects.create';
import { CompanyDeleteEffect } from './ngrx/company/company.effects.delete';
import { CompanyUpdateEffects } from './ngrx/company/company.effects.update';
import { CompanyGetEffects } from './ngrx/company/company.effects.get';
import { CompanyCreateEffects } from './ngrx/company/company.effects.create';
import { UserUpdateEffects } from './ngrx/user/user.effects.update';
import { UserDeleteEffect } from './ngrx/user/user.effects.delete';
import { UserSAddressManagerModule } from './pages/user-s-address-manager/user-s-address-manager.module';
import { AddressEffects } from './ngrx/user-s-address/address.effects';
import { UserGetAllEffects } from './ngrx/user/user.effects.get';
import { UserManagerModule } from './pages/user-manager/user-manager.module';
import { BasePageAccueilModule } from './pages/base-page-accueil/base-page-accueil.module';
import { ProjectManagerModule } from './pages/project-manager/project-manager.module';
import { CompanyManagerModule } from './pages/company-manager/company-manager.module';
import { NgModule } from '@angular/core';
import { BrowserModule } from '@angular/platform-browser';
import { EffectsModule } from '@ngrx/effects';
import { StoreModule } from '@ngrx/store';
import { StoreDevtoolsModule } from '@ngrx/store-devtools';

import { AppRoutingModule } from './app-routing.module';
import { AppComponent } from './app.component';
import { BrowserAnimationsModule } from '@angular/platform-browser/animations';
import { BaseNavMenuComponent } from './pages/base-nav-menu/base-nav-menu.component';
import { LayoutModule } from '@angular/cdk/layout';
import { MatToolbarModule } from '@angular/material/toolbar';
import { MatButtonModule } from '@angular/material/button';
import { MatSidenavModule } from '@angular/material/sidenav';
import { MatIconModule } from '@angular/material/icon';
import { MatListModule } from '@angular/material/list';
import { HttpClientModule } from '@angular/common/http';
import { userReducer } from './ngrx/user/user.reducer';
import { addressReducer } from './ngrx/user-s-address/address.reducer';
import { UserCreateEffects } from './ngrx/user/user.effects.create';
import { companyReducer } from './ngrx/company/company.reducer';
import { projectReducer } from './ngrx/project/project.reducer';

@NgModule({
  declarations: [AppComponent, BaseNavMenuComponent],
  imports: [
    BrowserModule,
    AppRoutingModule,
    StoreModule.forRoot({
      userReducerSelector: userReducer,
      addressReducerSelector: addressReducer,
      companyReducerSelector: companyReducer,
      projectReducerSelector: projectReducer,
    }),
    EffectsModule.forRoot([
      AddressEffects,
      UserGetAllEffects,
      UserCreateEffects,
      UserDeleteEffect,
      UserUpdateEffects,
      CompanyCreateEffects,
      CompanyGetEffects,
      CompanyUpdateEffects,
      CompanyDeleteEffect,
      ProjectCreateEffects,
      ProjectGetEffects,
      ProjectUpdateEffect,
      ProjectDeleteEffect
    ]),
    StoreDevtoolsModule.instrument(),
    BrowserAnimationsModule,
    LayoutModule,
    MatToolbarModule,
    MatButtonModule,
    MatSidenavModule,
    MatIconModule,
    MatListModule,
    BasePageAccueilModule,
    UserManagerModule,
    UserSAddressManagerModule,
    CompanyManagerModule,
    ProjectManagerModule,
    HttpClientModule,
  ],
  providers: [],
  bootstrap: [AppComponent],
})
export class AppModule {}
