import { map, catchError } from 'rxjs/operators';
import { CompanyActionTypes } from './company.action.type';
import { CompanyActionUnion, DeleteCompanyActionSuccess, DeleteCompanyActionError } from './company.actions';
import { Observable, mergeMap, of } from 'rxjs';
import { Actions, createEffect, ofType } from '@ngrx/effects';
import { CompanyService } from './../../shared/services/company.service';
import { Injectable } from "@angular/core";

@Injectable()
export class CompanyDeleteEffect {

  constructor(private companyService: CompanyService, private companyActions: Actions){}

  //delete company effect
  DeleteCompanyEffect: Observable<CompanyActionUnion> = createEffect(
    ()=> this.companyActions.pipe(
      ofType(CompanyActionTypes.DELETE_COMPANY),
      mergeMap((action: CompanyActionUnion) =>{
        return this.companyService.deleteCompany(action.payload.companyID).pipe(
          map( ()=> new DeleteCompanyActionSuccess(action.payload)),
          catchError( err => of( new DeleteCompanyActionError(err)) )
        )
      })
    )
  );
}
