import { ProjectActionTypes } from './project.action.type';
import { Action } from '@ngrx/store';
import { Project } from 'src/app/shared/models/project/project.model';

//create form to add project
export class CreateFormAddProjectAction implements Action {
  type: ProjectActionTypes = ProjectActionTypes.CREATE_FORM_ADD_PROJECT;
  constructor(public payload: any, public userID: any, public companyID: any) {}
}
export class CreateFormAddProjectActionSuccess implements Action {
  type: ProjectActionTypes = ProjectActionTypes.CREATE_FORM_ADD_PROJECT_SUCCESS;
  constructor(public payload: any, public userID: any, public companyID: any) {}
}
export class CreateFormAddProjectActionError implements Action {
  type: ProjectActionTypes = ProjectActionTypes.CREATE_FORM_ADD_PROJECT_ERROR;
  constructor(
    public payload: string,
    public userID: any,
    public companyID: any
  ) {}
}

// save new project
export class SaveNewProjectAction implements Action {
  type: ProjectActionTypes = ProjectActionTypes.SAVE_NEW_PROJECT;
  constructor(
    public payload: Project
  ) {}
}
export class SaveNewProjectActionSuccess implements Action {
  type: ProjectActionTypes = ProjectActionTypes.SAVE_NEW_PROJECT_SUCCESS;
  constructor(
    public payload: Project
  ) {}
}
export class SaveNewProjectActionError implements Action {
  type: ProjectActionTypes = ProjectActionTypes.SAVE_NEW_PROJECT_ERROR;
  constructor(
    public payload: string
  ) {}
}

// get all projects action
export class GetAllProjectAction implements Action {
  type: ProjectActionTypes = ProjectActionTypes.GET_ALL_PROJECTS;
  constructor(
    public payload: void
  ) {}
}
export class GetAllProjectActionSuccess implements Action {
  type: ProjectActionTypes = ProjectActionTypes.GET_ALL_PROJECTS_SUCCESS;
  constructor(
    public payload: Array<Project>
  ) {}
}
export class GetAllProjectActionError implements Action {
  type: ProjectActionTypes = ProjectActionTypes.GET_ALL_PROJECTS_ERROR;
  constructor(
    public payload: string
  ) {}
}

// create form update project
export class CreateFormUpdatedProjectAction implements Action {
  type: ProjectActionTypes = ProjectActionTypes.CREATE_FORM_UPDATE_PROJECT;
  constructor(
    public payload: Project,
    public userID: any,
    public companyID: any
  ) {}
}
export class CreateFormUpdatedProjectActionError implements Action {
  type: ProjectActionTypes =
    ProjectActionTypes.CREATE_FORM_UPDATE_PROJECT_ERROR;
  constructor(
    public payload: string,
    public userID: any,
    public companyID: any
  ) {}
}
export class CreateFormUpdatedProjectActionSuccess implements Action {
  type: ProjectActionTypes =
    ProjectActionTypes.CREATE_FORM_UPDATE_PROJECT_SUCCCESS;
  constructor(
    public payload: Project,
    public userID: any,
    public companyID: any
  ) {}
}

//update project
export class UpdateProjectAction implements Action {
  type: ProjectActionTypes = ProjectActionTypes.UPDATE_PROJECT;
  constructor(
    public payload: Project
  ) {}
}
export class UpdateProjectActionError implements Action {
  type: ProjectActionTypes = ProjectActionTypes.UPDATE_PROJECT_ERROR;
  constructor(
    public payload: string
  ) {}
}
export class UpdateProjectActionSuccess implements Action {
  type: ProjectActionTypes = ProjectActionTypes.UPDATE_PROJECT_SUCCESS;
  constructor(
    public payload: Project
  ) {}
}

// delete project
export class DeleteProjectAction implements Action{
  type: ProjectActionTypes = ProjectActionTypes.DELETE_PROJECT;
  constructor(
    public payload: Project
  ) {}
}
export class DeleteProjectActionSuccess implements Action{
  type: ProjectActionTypes = ProjectActionTypes.DELETE_PROJECT_SUCCESS;
  constructor(
    public payload: Project
  ) {}
}
export class DeleteProjectActionError implements Action{
  type: ProjectActionTypes = ProjectActionTypes.DELETE_PROJECT_ERROR;
  constructor(
    public payload: string
  ) {}
}


export type ProjectActionUnion =
  | CreateFormAddProjectAction
  | CreateFormAddProjectActionSuccess
  | CreateFormAddProjectActionError
  | SaveNewProjectAction
  | SaveNewProjectActionSuccess
  | SaveNewProjectActionError
  | GetAllProjectAction
  | GetAllProjectActionSuccess
  | GetAllProjectActionError
  | CreateFormUpdatedProjectAction
  | CreateFormUpdatedProjectActionSuccess
  | CreateFormUpdatedProjectActionError
  | UpdateProjectAction
  | UpdateProjectActionSuccess
  | UpdateProjectActionError
  | DeleteProjectAction
  | DeleteProjectActionSuccess
  | DeleteProjectActionError;
