import { DeleteCompanyAction, GetAllComapaniesAction } from './../../../../ngrx/company/company.actions';
import { CompanyState } from './../../../../ngrx/company/company.state';
import { MsgState } from 'src/app/ngrx/msg.state';
import { Router } from '@angular/router';
import { Company } from 'src/app/shared/models/company/company.model';
import { Component, OnInit, Input } from '@angular/core';
import { Store } from '@ngrx/store';

@Component({
  selector: 'app-companies-list',
  templateUrl: './companies-list.component.html',
  styleUrls: ['./companies-list.component.css']
})
export class CompaniesListComponent implements OnInit {

  constructor(private router: Router, private store: Store<{companyReducerSelector: CompanyState}>) { }

  @ Input () inputCompaniesList!: Array<Company>

  ngOnInit(): void {
  }

  onCompanyEdit(company: Company){
    this.router.navigateByUrl("/company-update/"+company.companyID);
  }

  onCompanyDelete(company:Company){
    if(window.confirm(MsgState.CONFIRM_DEL)){
      this.store.dispatch(new DeleteCompanyAction(company));
    }
  }

  companyName!: string;

  onSearch() {
    if(this.companyName==''){
      this.store.dispatch(new GetAllComapaniesAction({})); //refresh
    }
    else{
      this.inputCompaniesList = this.inputCompaniesList.filter((company: Company) => {
        return company.companyName
          .toLocaleLowerCase()
          .match(this.companyName.toLocaleLowerCase());
      });
    }
  }
}
