import { Router } from '@angular/router';
import { Observable } from 'rxjs';
import { UserState } from './../../../ngrx/user/user.state';
import { Component, OnInit } from '@angular/core';
import { Store } from '@ngrx/store';
import { MsgState } from 'src/app/ngrx/msg.state';

@Component({
  selector: 'app-user-management',
  templateUrl: './user-management.component.html',
  styleUrls: ['./user-management.component.css'],
})
export class UserManagementComponent implements OnInit {
  userState$!: Observable<UserState>;
  constructor(
    private store: Store<{ userReducerSelector: UserState }>,
    private router: Router
  ) {}
  msgState = MsgState;
  errorMsg!: string;

  ngOnInit(): void {
    this.userState$ = this.store.select('userReducerSelector');
  }
}
