import { ReactiveFormsModule } from '@angular/forms';
import { TableModule } from 'primeng/table';
import { ButtonModule } from 'primeng/button';
import { NgModule } from '@angular/core';
import { CommonModule } from '@angular/common';

import { UserSAddressManagerRoutingModule } from './user-s-address-manager-routing.module';
import { AddressManagementComponent } from './address-management/address-management.component';
import { AddressNavbarComponent } from './address-management/address-navbar/address-navbar.component';
import { AddressesListComponent } from './address-management/addresses-list/addresses-list.component';
import { AddressCreateComponent } from './address-management/address-create/address-create.component';
import { AddressUpdateComponent } from './address-management/address-update/address-update.component';


@NgModule({
  declarations: [
    AddressManagementComponent,
    AddressNavbarComponent,
    AddressesListComponent,
    AddressCreateComponent,
    AddressUpdateComponent
  ],
  imports: [
    CommonModule,
    UserSAddressManagerRoutingModule,
    ButtonModule,
    TableModule,
    ReactiveFormsModule
  ]
})
export class UserSAddressManagerModule { }
